import java.util.ArrayList;


public class Router 
{
	public String name;
	ArrayList <Router> neighbors = new ArrayList<Router>();
	ArrayList <Integer> neb_delays = new ArrayList<Integer>();
	private Router parent = null;
	public int cost = Integer.MAX_VALUE;
	
	public Router(String name)
	{
		this.name = name;
	}
	
	public void reset()
	{
		parent = null;
		cost = Integer.MAX_VALUE;
	}
	
	/**
	 * do a depth-first search at this node
	 */
	public void DFS()
	{
		int nextVal = cost + 1;
		
		for (Router r : neighbors)
		{
			if (r.cost > nextVal)
			{
				r.parent = this;
				r.cost = nextVal;
				r.DFS();
			}
		}
	}
	
	/**
	 * Find the first child of the source
	 * @return the Router that's the first child from the source.
	 */
	public Router findFirstParent()
	{
		Router rv = this;
		
		for (Router r = parent; r != null; r = r.parent)
		{
			if (r.parent != null)
				rv = r;
		}
		
		return rv;
	}
	
	public String toString()
	{
		return "[Router " + name + "(cost:" + cost + ")]";
	}
}
