----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:54:12 12/17/2008 
-- Design Name: 
-- Module Name:    my_bram - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity my_bram is
generic(
	ADDR_WIDTH : integer := 8;
	DATA_WIDTH : integer := 48
);
port(
	clock : in std_logic;
	addr : in std_logic_vector(ADDR_WIDTH - 1 downto 0);
	data_in : in std_logic_vector(DATA_WIDTH - 1 downto 0);
	write_enable : in std_logic;
	
	data_out : out std_logic_vector(DATA_WIDTH - 1 downto 0)
);
end my_bram;

architecture Behavioral of my_bram is

constant ram_enable : std_logic := '1';
type ram_type is array (2**ADDR_WIDTH-1 downto 0) of std_logic_vector (DATA_WIDTH-1 downto 0);
signal ram: ram_type;

begin



process (clock)
begin
   if clock'event and clock = '1' then
      if ram_enable = '1' then 
         if write_enable = '1' then
            ram(conv_integer(addr)) <= data_in;
				data_out <= data_in;
         else
            data_out <= ram(conv_integer(addr));
         end if;
      end if;
   end if;
end process;

end Behavioral;

