-- Stan Bak
-- Traffic Generator for network simulator - 12-15-08

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use work.bak.all;

entity traffic_gen is
	generic	
	(	
		DESTINATION : std_logic_vector(7 downto 0) := (others => '0')
	);
	port 
	( 
		clock			: in std_logic;
		proceed			: in std_logic;
		gen_ack			: in std_logic;
		enable			: in std_logic;
		
		gen_task 		: out std_logic := '0';
		gen_dest 		: out std_logic_vector(7 downto 0) := (others => '0')
	); 
end traffic_gen;

architecture Behavioral of traffic_gen is

signal timeUntilGen : integer range 0 to 1023 := 0;

begin

gen_dest <= DESTINATION;

process (clock) begin
	if rising_edge(clock) then
	
		if gen_ack = '1' then
			gen_task <= '0';
		end if;
		
		if proceed = '1' then
			if timeUntilGen > 0 then
				timeUntilGen <= timeUntilGen - 1;
			elsif enable = '1' then		
				timeUntilGen <= 999;
				gen_task <= '1';
			end if;
		end if;
	end if;

end process;

end Behavioral;
