#!/bin/bash

#clear data file
echo -n "" > data.txt

# for 2 to 29
for ((i = 9; i <= 9; i++))
do
  # print current iteration
  echo "Current Iteration: i = $i"

  # print factor
  echo -n -e "$i\t" >> data.txt

  # step 1, run tiers
  tiers 1 `echo "(3.0*$i.0/10.0)/1" | bc` `echo "(4.0*$i.0/10.0)/1" | bc` `echo "(10.0*$i.0/10.0)/1" | bc` `echo "(10.0*$i.0/10.0)/1" | bc` `echo "(5.0*$i.0/10.0)/1" | bc` 0 > tmp/top.tiers

  # step 2, generate ns topology
  ./t2n < tmp/top.tiers > tmp/top.ns

  # step 3, measure ns
  (time ns tmp/top.ns) 2> tmp/out.txt

  # step 4, parse time outout
  tail -n 2 tmp/out.txt | head -n 1 | head -c -2 | tail -c 8 | ./parsetime >> data.txt

  echo -n -e "\t" >> data.txt

  # print num routers
  echo "(10.0*$i.0/10.0)/1 + (3.0*$i.0/10.0)/1*(10.0*$i.0/10.0)/1 + (3.0*$i.0/10.0)/1*(4.0*$i.0/10.0)/1*(5.0*$i.0/10.0)/1" | bc >> data.txt

done

# create graph
./graph.plt



